
--------------------------------------
-- Namespaces
--------------------------------------
local _, core = ...;
core.Config = {}; -- adds Config table to addon namespace
ZishorRaidResetDB = {}
ZishorRaidResetTimers = {}
ZishorRaidResetTimersAdaption = {}
local Config = core.Config;
local UIConfig, menu;
local UIText, MCText, ONYText, BWLText, ZGText, INFOText, INFOTextID, nextAvailableMC, nextAvailableOny, nextAvailableZG, nextAvailableBWL;
local timerMC, timerOny, timerBWL, timerZG;
--------------------------------------
-- Defaults (usually a database!)
--------------------------------------
local defaults = {
	theme = {
		r = 0, 
		g = 0.8, -- 204/255
		b = 1,
		hex = "00ccff"
	}
}

local OnyResetDate, ZGResetDate, MCBWLResetDate;

local raidNames ={
"Onyxia's Lair", 
"Blackwing Lair", 
"Molten Core", 
"Zul'Gurub", 
"Ruins of Ahn'Qiraj", 
"Naxxramas",
 "Ahn'Qiraj"
}
-- Config functions
--------------------------------------

function Config:OnLogin()

MCBWLResetDate = time{year=2020, month=5, day=06, hour=09, minute=00}
OnyResetDate  = time{year=2020, month=5, day=03, hour=09, minute=00}
ZGResetDate = time{year=2020, month=5, day=01, hour=09, minute=00}
ZishorRaidResetTimers[1] = MCBWLResetDate
ZishorRaidResetTimers[2] = OnyResetDate
ZishorRaidResetTimers[3] = ZGResetDate


end
function Config:GetThemeColor()
	local c = defaults.theme;
	return c.r, c.g, c.b, c.hex;
end

function Config:CreateButton(point, relativeFrame, relativePoint, yOffset, text)
	local btn = CreateFrame("Button", nil, UIConfig.ScrollFrame, "GameMenuButtonTemplate");
	btn:SetPoint(point, relativeFrame, relativePoint, 0, yOffset);
	btn:SetSize(140, 40);
	btn:SetText(text);
	btn:SetNormalFontObject("GameFontNormalLarge");
	btn:SetHighlightFontObject("GameFontHighlightLarge");
	return btn;
end

function Config:FrameUpdateHandler()
	
		if menu:IsShown() == true then
			--close frame without Timer update
			menu:SetShown(false)
			
		else
			--Update Timer b4 open the frame
			
			Config:UpdateResetTimer();
			menu:SetShown(true)
			
			
		end
end

function Config:CheckTimers()

oneDayTimer = 86400;
--initial Timers
MCBWLResetDate = time{year=2020, month=5, day=06, hour=09, minute=00}
OnyResetDate  = time{year=2020, month=5, day=03, hour=09, minute=00}
ZGResetDate = time{year=2020, month=5, day=01, hour=09, minute=00}

actualTime = time()

actualTime = actualTime

		--fill database with values to recalculate reset timers
		ZishorRaidResetTimersAdaption[1] = 604800;
		ZishorRaidResetTimersAdaption[2] = 432000;
		ZishorRaidResetTimersAdaption[3] = 259200;

	if next(ZishorRaidResetTimers) == nil then
		--fill database with inital values
		ZishorRaidResetTimers[1] = MCBWLResetDate
		ZishorRaidResetTimers[2] = OnyResetDate
		ZishorRaidResetTimers[3] = ZGResetDate

	end
	for i = 1, 3 do 
		if (ZishorRaidResetTimers[i] < actualTime) then
			
			for j = 1, 366 do 
				--Then we need to revaluate the next reset timer
				--TODO bis 1 jahr nachjustieren 1 jahr = 31 536 000 oder halt 365 mal nachjustieren lol 
				ZishorRaidResetTimers[i] = ZishorRaidResetTimers[i] + ZishorRaidResetTimersAdaption[i]
				if (ZishorRaidResetTimers[i] > actualTime) then
				
					break;
				
				end
			
			end
			
		end


	end


end

function Config:UpdateResetTimer()
	--Checks the timers of all raids if they are right, adjusts them if needed and store them in the DB
	Config:CheckTimers()
	
	--Before we update all timer we set everything to no, because we first check if IDs are there and then we handle the raids with no ID
	Config:NoIDsExisting()
	
	for i = 1 , 4 do
	name, id, reset = GetSavedInstanceInfo(i)
	
		if name == nil and i == 1 then 
			-- if the first entry is nil no IDs are existing, so we can exit the for loop
			
			Config:CheckForNoId();
			return;
			
			
		else	
			if raidNames[1] == name then
			-----------Ony--------------
			 
			 
			 timerOny:SetText("Yes")
				
			 numberOfDays = (reset / 86400);
			 numberOfHours = ((reset % 86400 ) / 3600) ;
			 numberOfMinutes = (((reset % 86400 ) % 3600 ) / 60) 
	
			 if numberOfDays < 1 then
			 
					numberOfHours =  math.floor(numberOfHours+0.0)
					numberOfMinutes =  math.floor(numberOfMinutes+0.0)
					nextAvailableOny:SetText(numberOfHours .. " hrs " .. numberOfMinutes .. " mins")
			 else
				if numberOfHours < 1 then
					numberOfDays =  math.floor(numberOfDays+0.0)
					numberOfHours =  math.floor(numberOfHours+0.0)
					numberOfMinutes =  math.floor(numberOfMinutes+0.0)
					nextAvailableOny:SetText(numberOfDays .. " days " .. numberOfMinutes .. " mins")
				
				else
					numberOfDays =  math.floor(numberOfDays+0.0)
					numberOfHours =  math.floor(numberOfHours+0.0)
					numberOfMinutes =  math.floor(numberOfMinutes+0.0)
					nextAvailableOny:SetText(numberOfDays .. " days " .. numberOfHours .. " hrs")
				end
			 end

			end
		
			if raidNames[2] == name then
			----------BWL--------------
			 timerBWL:SetText("Yes")
			 numberOfDays = (reset / 86400);
			 numberOfHours = ((reset % 86400 ) / 3600) ;
			 numberOfMinutes = (((reset % 86400 ) % 3600 ) / 60) 
			 
			 
			 if numberOfDays < 1 then
			 
					numberOfHours =  math.floor(numberOfHours+0.0)
					numberOfMinutes =  math.floor(numberOfMinutes+0.0)
					nextAvailableBWL:SetText(numberOfHours .. " hrs " .. numberOfMinutes .. " mins")		
			 else
			 
				if numberOfHours < 1 then
					
					numberOfDays =  math.floor(numberOfDays+0.0)
					numberOfHours =  math.floor(numberOfHours+0.0) - (numberOfDays * 24)
					numberOfMinutes =  math.floor(numberOfMinutes+0.0)
					nextAvailableBWL:SetText(numberOfDays .. " days " .. numberOfMinutes .. " mins")
				
				
				else
				
					if numberOfHours < 1 then
					
						numberOfDays =  math.floor(numberOfDays+0.0)
						numberOfHours =  math.floor(numberOfHours+0.0) - (numberOfDays * 24)
						numberOfMinutes =  math.floor(numberOfMinutes+0.0)
						nextAvailableBWL:SetText(numberOfDays .. " days " .. numberOfMinutes .. " mins")

					
					else
						numberOfDays =  math.floor(numberOfDays+0.0)
						numberOfHours =  math.floor(numberOfHours+0.0) - (numberOfDays * 24)
						numberOfMinutes =  math.floor(numberOfMinutes+0.0)
						nextAvailableBWL:SetText(numberOfDays .. " days " .. numberOfHours .. " hrs")
					end
					
				end
			 end
			 
			 
			 
			end
			
			if raidNames[3] == name then
			-----------MC--------------
			 timerMC:SetText("Yes")
			 numberOfDays = (reset / 86400);
			 numberOfHours = ((reset % 86400 ) / 3600) ;
			 numberOfMinutes = (((reset % 86400 ) % 3600 ) / 60) 
				
				if numberOfDays < 1 then
			 
					numberOfHours =  math.floor(numberOfHours+0.0)
					numberOfMinutes =  math.floor(numberOfMinutes+0.0)
					nextAvailableMC:SetText(numberOfHours .. " hrs " .. numberOfMinutes .. " mins")		
			 else
			 
				if numberOfHours < 1 then
					
					numberOfDays =  math.floor(numberOfDays+0.0)
					numberOfHours =  math.floor(numberOfHours+0.0) - (numberOfDays * 24)
					numberOfMinutes =  math.floor(numberOfMinutes+0.0)
					nextAvailableMC:SetText(numberOfDays .. " days " .. numberOfMinutes .. " mins")
				
				
				else
				
					if numberOfHours < 1 then
					
						numberOfDays =  math.floor(numberOfDays+0.0)
						numberOfHours =  math.floor(numberOfHours+0.0) - (numberOfDays * 24)
						numberOfMinutes =  math.floor(numberOfMinutes+0.0)
						nextAvailableMC:SetText(numberOfDays .. " days " .. numberOfMinutes .. " mins")

					
					else
						numberOfDays =  math.floor(numberOfDays+0.0)
						numberOfHours =  math.floor(numberOfHours+0.0) - (numberOfDays * 24)
						numberOfMinutes =  math.floor(numberOfMinutes+0.0)
						nextAvailableMC:SetText(numberOfDays .. " days " .. numberOfHours .. " hrs")
					end
					
				end
			 end
				
				
			end
			if raidNames[4] == name then
			
			-----------ZG--------------
			 timerZG:SetText("Yes")
			 numberOfDays = (reset / 86400);
			 numberOfHours = ((reset % 86400 ) / 3600) ;
			 numberOfMinutes = (((reset % 86400 ) % 3600 ) / 60) 
	
			 if numberOfDays < 1 then
			 
					numberOfHours =  math.floor(numberOfHours+0.0)
					numberOfMinutes =  math.floor(numberOfMinutes+0.0)
					nextAvailableZG:SetText(numberOfHours .. " hrs " .. numberOfMinutes .. " mins")		
			 else
			 
				if numberOfHours < 1 then
					
					numberOfDays =  math.floor(numberOfDays+0.0)
					numberOfHours =  math.floor(numberOfHours+0.0) - (numberOfDays * 24)
					numberOfMinutes =  math.floor(numberOfMinutes+0.0)
					nextAvailableZG:SetText(numberOfDays .. " days " .. numberOfMinutes .. " mins")
				
				
				else
						
					if numberOfHours < 1 then
					
						numberOfDays =  math.floor(numberOfDays+0.0)
						numberOfHours =  math.floor(numberOfHours+0.0) - (numberOfDays * 24)
						numberOfMinutes =  math.floor(numberOfMinutes+0.0)
						nextAvailableZG:SetText(numberOfDays .. " days " .. numberOfMinutes .. " mins")

					
					else
						numberOfDays =  math.floor(numberOfDays+0.0)
						numberOfHours =  math.floor(numberOfHours+0.0) - (numberOfDays * 24)
						numberOfMinutes =  math.floor(numberOfMinutes+0.0)
						nextAvailableZG:SetText(numberOfDays .. " days " .. numberOfHours .. " hrs")
					end
					
				end
			 end
			
		 
		 end
			
		end
		
	end
	
	Config:CheckForNoId();
	
	
	
end


function Config:CheckForNoId()

	
	if  timerMC:GetText() == nil  or  timerMC:GetText() ~= "Yes" then
			timerMC:SetText("No")
			diff = difftime(ZishorRaidResetTimers[1], time())
			numberOfDays = (diff / 86400);
			numberOfHours = ((diff % 86400 ) / 3600) ;
			numberOfMinutes = (((diff) % 3600 ) / 60) 
			
			 if numberOfDays < 1 then
					 
				numberOfHours =  math.floor(numberOfHours+0.0)
				numberOfMinutes =  math.floor(numberOfMinutes+0.0)
				nextAvailableMC:SetText(numberOfHours .. " hrs " .. numberOfMinutes .. " mins")
	
			else
				
				if numberOfHours < 1 then
				
					numberOfDays =  math.floor(numberOfDays+0.0)
					numberOfHours =  math.floor(numberOfHours+0.0) 
					numberOfMinutes =  math.floor(numberOfMinutes+0.0)
					nextAvailableMC:SetText(numberOfDays .. " days " .. numberOfMinutes .. " mins")
				
				else
					numberOfDays =  math.floor(numberOfDays+0.0)
					numberOfHours =  math.floor(numberOfHours+0.0)
					numberOfMinutes =  math.floor(numberOfMinutes+0.0)
					nextAvailableMC:SetText(numberOfDays .. " days " .. numberOfHours .. " hrs")
				end
			 end
	
	end
	
	if  timerBWL:GetText() == nil  or timerBWL:GetText() ~= "Yes" then
			timerBWL:SetText("No")
		
			diff = difftime(ZishorRaidResetTimers[1], time())
			numberOfDays = (diff / 86400);
			numberOfHours = ((diff % 86400 ) / 3600) ;
			numberOfMinutes = (((diff) % 3600 ) / 60) 
			
			 if numberOfDays < 1 then
					 
				numberOfHours =  math.floor(numberOfHours+0.0)
				numberOfMinutes =  math.floor(numberOfMinutes+0.0)
				nextAvailableBWL:SetText(numberOfHours .. " hrs " .. numberOfMinutes .. " mins")
	
			else
			
				if numberOfHours < 1 then
					numberOfDays =  math.floor(numberOfDays+0.0)
					numberOfHours =  math.floor(numberOfHours+0.0) 
					numberOfMinutes =  math.floor(numberOfMinutes+0.0)
					nextAvailableBWL:SetText(numberOfDays .. " days " .. numberOfMinutes .. " mins")
					
				else
					numberOfDays =  math.floor(numberOfDays+0.0)
					numberOfHours =  math.floor(numberOfHours+0.0) 
					numberOfMinutes =  math.floor(numberOfMinutes+0.0)
					nextAvailableBWL:SetText(numberOfDays .. " days " .. numberOfHours .. " hrs")
				end
			 end
			
	end
	
	if   timerZG:GetText() == nil  or  timerZG:GetText() ~= "Yes" then
			timerZG:SetText("No")
			
			diff = difftime(ZishorRaidResetTimers[3], time())
			numberOfDays = (diff / 86400);
			numberOfHours = ((diff % 86400 ) / 3600) ;
			numberOfMinutes = (((diff) % 3600 ) / 60) 
			
			 if numberOfDays < 1 then
					 
				numberOfHours =  math.floor(numberOfHours+0.0)
				numberOfMinutes =  math.floor(numberOfMinutes+0.0)
				nextAvailableZG:SetText(numberOfHours .. " hrs " .. numberOfMinutes .. " mins")
	
			else
			
				if numberOfHours < 1 then
					numberOfDays =  math.floor(numberOfDays+0.0)
					numberOfHours =  math.floor(numberOfHours+0.0) 
					numberOfMinutes =  math.floor(numberOfMinutes+0.0)
					nextAvailableZG:SetText(numberOfDays .. " days " .. numberOfMinutes .. " mins")
				
				else
					numberOfDays =  math.floor(numberOfDays+0.0)
					numberOfHours =  math.floor(numberOfHours+0.0) 
					numberOfMinutes =  math.floor(numberOfMinutes+0.0)
					nextAvailableZG:SetText(numberOfDays .. " days " .. numberOfHours .. " hrs")
				end
			 end
			
			
	
	end
	
	if  timerOny:GetText() == nil  or timerOny:GetText() ~= "Yes" then
			timerOny:SetText("No")
			
			diff = difftime(ZishorRaidResetTimers[2], time())
			numberOfDays = (diff / 86400);
			numberOfHours = ((diff % 86400 ) / 3600) ;
			numberOfMinutes = (((diff) % 3600 ) / 60) 
			
			 if numberOfDays < 1 then
					 
				numberOfHours =  math.floor(numberOfHours+0.0)
				numberOfMinutes =  math.floor(numberOfMinutes+0.0)
				nextAvailableOny:SetText(numberOfHours .. " hrs " .. numberOfMinutes .. " mins")
	
			else
				if numberOfHours < 1 then
					numberOfDays =  math.floor(numberOfDays+0.0)
					numberOfHours =  math.floor(numberOfHours+0.0) 
					numberOfMinutes =  math.floor(numberOfMinutes+0.0)
					nextAvailableOny:SetText(numberOfDays .. " days " .. numberOfMinutes .. " mins")
				
				else
					numberOfDays =  math.floor(numberOfDays+0.0)
					numberOfHours =  math.floor(numberOfHours+0.0) 
					numberOfMinutes =  math.floor(numberOfMinutes+0.0)
					nextAvailableOny:SetText(numberOfDays .. " days " .. numberOfHours .. " hrs")
				end
			 end
	
	end

end



function Config:NoIDsExisting()
	
	timerMC:SetText("No")
	timerOny:SetText("No")
	timerBWL:SetText("No")
	timerZG:SetText("No")

end

function Config:CreateMenu()

	UIConfig = CreateFrame("Frame", "ZishorRaidReset", UIParent, "UIPanelDialogTemplate");
	UIConfig:SetSize(350, 400);
	UIConfig:SetPoint("CENTER"); -- Doesn't need to be ("CENTER", UIParent, "CENTER")
	
	--movable Frame
	UIConfig:SetMovable(true);
	UIConfig:EnableMouse(true);
	UIConfig:RegisterForDrag("LeftButton")
	UIConfig:SetScript("OnDragStart", UIConfig.StartMoving)
	UIConfig:SetScript("OnDragStop", UIConfig.StopMovingOrSizing)

	--set Text
	
	INFOText = UIConfig:CreateFontString(nil, "OVERLAY", "GameFontDisable")
	INFOText:SetPoint("TOPLEFT", 20, -40)
	INFOText:SetText("Instance")
	
	INFOTextID = UIConfig:CreateFontString(nil, "OVERLAY", "GameFontDisable")
	INFOTextID:SetPoint("TOPLEFT", 120, -40)
	INFOTextID:SetText("ID")
	
	INFOTextNextAvailable = UIConfig:CreateFontString(nil, "OVERLAY", "GameFontDisable")
	INFOTextNextAvailable:SetPoint("TOPLEFT", 180, -40)
	INFOTextNextAvailable:SetText("Next Reset")
	
	MCText = UIConfig:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	MCText:SetPoint("TOPLEFT", 20, -80)
	MCText:SetText("MC")
	
	timerMC = UIConfig:CreateFontString(nil, "MCTimer", "GameFontNormal")
	timerMC:SetPoint("TOPLEFT", 120, -80)
	
	nextAvailableMC = UIConfig:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	nextAvailableMC:SetPoint("TOPLEFT", 180, -80)
	
	ONYText = UIConfig:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	ONYText:SetPoint("TOPLEFT", 20, -120)
	ONYText:SetText("Ony")
	
	timerOny = UIConfig:CreateFontString(nil, "OnyTimer", "GameFontNormal")
	timerOny:SetPoint("TOPLEFT", 120, -120)
	
	nextAvailableOny = UIConfig:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	nextAvailableOny:SetPoint("TOPLEFT", 180, -120)
	
	BWLText = UIConfig:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	BWLText:SetPoint("TOPLEFT", 20, -160)
	BWLText:SetText("BWL")
	
	timerBWL = UIConfig:CreateFontString(nil, "BWLTimer", "GameFontNormal")
	timerBWL:SetPoint("TOPLEFT", 120, -160)
	
	nextAvailableBWL = UIConfig:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	nextAvailableBWL:SetPoint("TOPLEFT", 180, -160)
	
	ZGText = UIConfig:CreateFontString(nil, "ZG", "GameFontNormal")
	ZGText:SetPoint("TOPLEFT", 20, -200)
	ZGText:SetText("ZG")
	
	timerZG = UIConfig:CreateFontString(nil, "ZGTimer", "GameFontNormal")
	timerZG:SetPoint("TOPLEFT", 120, -200)
	
	nextAvailableZG = UIConfig:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	nextAvailableZG:SetPoint("TOPLEFT", 180, -200)
	
	UIConfig:Hide();
	return UIConfig;
end

local addon = LibStub("AceAddon-3.0"):NewAddon("ZishorRiadReset", "AceConsole-3.0")
local ZishorRiadResetLDB = LibStub("LibDataBroker-1.1"):NewDataObject("ZishorRiadReset!", {
    type = "data source",
    text = "ZishorRiadReset!",
    icon = "Interface\\Icons\\ability_dualwield",
	OnTooltipShow = function(tooltip)
          tooltip:SetText("Zishor Raid Reset")
          tooltip:AddLine("Left Hold: drag icon", 1, 2, 3)
		  tooltip:AddLine("Left/Right Click: open addon", 1, 2, 3)
          tooltip:Show()
     end,
    OnClick = function ()
	menu = UIConfig or Config:CreateMenu();
	Config:FrameUpdateHandler()
end
})
local icon = LibStub("LibDBIcon-1.0")
 
function addon:OnInitialize()
    -- Obviously you'll need a ## SavedVariables: ZishorRaidResetDB line in your TOC, duh!
    self.db = LibStub("AceDB-3.0"):New("ZishorRaidResetDB", {
        profile = {
            minimap = {
                hide = false,
            },
        },
    })
    icon:Register("ZishorRiadReset!", ZishorRiadResetLDB, self.db.profile.minimap)
    
end

